#ifndef _FTPSERV_H
#define _FTPSERV_H
  
#include <stdio.h>
  
#ifndef _SOCKADDR_H
#include "sockaddr.h"
#endif
  
#ifndef _TIMER_H
#include "timer.h"
#endif
  
#define CTLZ    26              /* EOF for CP/M systems */
  
extern char *Userfile;  /* List of user names and permissions */
  
struct ftpserv {
    int control;            /* Control socket */
    int data;               /* Data socket */
    char type;              /* Transfer type */
    int logbsize;           /* Logical byte size for logical type */
  
    FILE *fp;               /* File descriptor being transferred */
    struct sockaddr_in port;/* Remote port for data connection */
    char *username;         /* Arg to USER command */
    char *path;             /* Allowable path prefix */
    char *cd;               /* Current directory name */
    char *root;             /* User's root directory */
    long ttim;              /* Challenge for encrypted password */
    int  uselzw;            /* Socket want's LZW compression.   */
    int  lzwbits;
    int  lzwmode;
};
  
/* FTP commands */
#define USER_CMD        0
#define ACCT_CMD        1
#define PASS_CMD        2
#define TYPE_CMD        3
#define LIST_CMD        4
#define CWD_CMD         5
#define DELE_CMD        6
#define QUIT_CMD        7
#define RETR_CMD        8
#define STOR_CMD        9
#define PORT_CMD        10
#define NLST_CMD        11
#define PWD_CMD         12
#define XPWD_CMD        13
#define MKD_CMD         14
#define XMKD_CMD        15
#define XRMD_CMD        16
#define RMD_CMD         17
#define STRU_CMD        18
#define MODE_CMD        19
#define RSME_CMD        20
#define RPUT_CMD        21
#define NOOP_CMD        22
#define SYST_CMD        23
#define PASV_CMD        24    /*PASV mod*/
#define HELP_CMD        25
#define RNFR_CMD        26
#define RNTO_CMD        27
#define APPE_CMD        28
#define SIZE_CMD        29
#define LZW_CMD         30
  
#endif  /* _FTPSERV_H */
